org.eclipse.gef.ui.actions

## Class UndoAction

- java.lang.Object
- - org.eclipse.core.commands.common.EventManager
  - - org.eclipse.jface.action.AbstractAction
    - - org.eclipse.jface.action.Action
      - - org.eclipse.gef.ui.actions.WorkbenchPartAction
        - - org.eclipse.gef.ui.actions.StackAction
          - - org.eclipse.gef.ui.actions.UndoAction

All Implemented Interfaces:
  Disposable, UpdateAction, IAction

    public class UndoAction
    extends StackAction

An action to undo the last command.

### Field Summary

### Fields inherited from interface org.eclipse.jface.action.IAction

`AS_CHECK_BOX, AS_DROP_DOWN_MENU, AS_PUSH_BUTTON, AS_RADIO_BUTTON, AS_UNSPECIFIED, CHECKED, DESCRIPTION, ENABLED, HANDLED, IMAGE, RESULT, TEXT, TOOL_TIP_TEXT`

### Constructor Summary

Constructors
Constructor and Description
`UndoAction(IEditorPart editor)` Creates an `UndoAction` and associates it with the given editor.
`UndoAction(IWorkbenchPart part)` Creates an `UndoAction` and associates it with the given editor.

### Method Summary

Methods
`protected boolean` `calculateEnabled()` Calculates and returns the enabled state of this action.
`protected void` `init()` Initializes this action's text and images.
`protected void` `refresh()` Refreshes this action's text to use the last executed command's label.
`void` `run()` Undoes the last command.

### Methods inherited from class org.eclipse.gef.ui.actions.StackAction

`getLabelForCommand`

### Methods inherited from class org.eclipse.gef.ui.actions.WorkbenchPartAction

`dispose, execute, getCommandStack, getWorkbenchPart, isEnabled, setLazyEnablementCalculation, setWorkbenchPart, update`

### Methods inherited from class org.eclipse.jface.action.Action

`convertAccelerator, convertAccelerator, findKeyCode, findKeyString, findModifier, findModifierString, getAccelerator, getActionDefinitionId, getDescription, getDisabledImageDescriptor, getHelpListener, getHoverImageDescriptor, getId, getImageDescriptor, getMenuCreator, getStyle, getText, getToolTipText, isChecked, isHandled, notifyResult, removeAcceleratorText, removeMnemonics, runWithEvent, setAccelerator, setActionDefinitionId, setChecked, setDescription, setDisabledImageDescriptor, setEnabled, setHelpListener, setHoverImageDescriptor, setId, setImageDescriptor, setMenuCreator, setText, setToolTipText`

### Methods inherited from class org.eclipse.jface.action.AbstractAction

`addPropertyChangeListener, firePropertyChange, firePropertyChange, removePropertyChangeListener`

### Methods inherited from class org.eclipse.core.commands.common.EventManager

`addListenerObject, clearListeners, getListeners, isListenerAttached, removeListenerObject`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### UndoAction

    public UndoAction(IEditorPart editor)

Creates an `UndoAction` and associates it with the given editor.

Parameters:
  `editor` - The editor this action is associated with.

#### UndoAction

    public UndoAction(IWorkbenchPart part)

Creates an `UndoAction` and associates it with the given editor.

Parameters:
  `part` - The workbench part this action is associated with.

### Method Detail

#### calculateEnabled

    protected boolean calculateEnabled()

Description copied from class: `WorkbenchPartAction`
Calculates and returns the enabled state of this action.

Specified by:
  `calculateEnabled` in class `WorkbenchPartAction`
Returns:
  `true` if the action is enabled
See Also:
  `WorkbenchPartAction.calculateEnabled()`

#### init

    protected void init()

Initializes this action's text and images.

Overrides:
  `init` in class `WorkbenchPartAction`

#### refresh

    protected void refresh()

Refreshes this action's text to use the last executed command's label.

Overrides:
  `refresh` in class `WorkbenchPartAction`

#### run

    public void run()

Undoes the last command.

Specified by:
  `run` in interface `IAction`
Overrides:
  `run` in class `Action`